//+------------------------------------------------------------------+
//|                                                 Glitch index.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  Green
#property indicator_color3  FireBrick
#property indicator_color4  Red
#property indicator_color5  DimGray
#property indicator_color6  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  1
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    SMAPeriod = 30;
extern double level1    = 2.0;
extern double level2    = 5.0;

//
//
//
//
//

double gliBufferUa[];
double gliBufferUb[];
double gliBufferDa[];
double gliBufferDb[];
double gliBufferNe[];
double gliBuffer[];
double smaBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,gliBufferUa); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,gliBufferUb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,gliBufferDb); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,gliBufferDa); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,gliBufferNe); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,gliBuffer);
   SetIndexBuffer(6,smaBuffer);
      SetLevelValue(0,0);
      SetLevelValue(1, level1);
      SetLevelValue(2, level2);
      SetLevelValue(3,-level1);
      SetLevelValue(4,-level2);
      
   return(0);
}
int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      smaBuffer[i] = iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      
         double rocSma = ((smaBuffer[i]-smaBuffer[i+1])*0.1)+1.0;
         double smaMul = smaBuffer[i]*rocSma;
         double diff   = Close[i]-smaMul;
         
      //
      //
      //
      //
      //
               
      gliBuffer[i]   = (diff/Close[i])*100.0;
      gliBufferUa[i] = EMPTY_VALUE;
      gliBufferUb[i] = EMPTY_VALUE;
      gliBufferDb[i] = EMPTY_VALUE;
      gliBufferDa[i] = EMPTY_VALUE;
         if (gliBuffer[i] >  level2) { gliBufferUa[i] = gliBuffer[i]; continue; }
         if (gliBuffer[i] >  level1) { gliBufferUb[i] = gliBuffer[i]; continue; }
         if (gliBuffer[i] < -level2) { gliBufferDa[i] = gliBuffer[i]; continue; }
         if (gliBuffer[i] < -level1) { gliBufferDb[i] = gliBuffer[i]; continue; }
                                       gliBufferNe[i] = gliBuffer[i];
   }
   return(0);
}